from Components.VariableText import VariableText
from enigma import eLabel, iServiceInformation
from Renderer import Renderer



class SmartLabel(Renderer, VariableText):
	def __init__(self):
		Renderer.__init__(self)
		VariableText.__init__(self)

	GUI_WIDGET = eLabel

	def changed(self, what):
		service = self.source.service
		info = service and service.info()
		if info is not None:
			if (info.getInfo(iServiceInformation.sIsCrypted) == 1):
				decID = ""
				decFrom = ""
				xresol = 0
				yresol = 0
				try:
					f = open("/tmp/ecm.info", "r")
					flines = f.readlines()
					f.close()
					for cell in flines:
						if ("caid" in cell)or("CAID" in cell)or("CaID" in cell)or("caID" in cell)or("Caid" in cell):
							cellmembers = cell.split()
							for x in range(len(cellmembers)):
								if ("caid" in cellmembers[x])or("CAID" in cellmembers[x])or("CaID" in cellmembers[x])or("caID" in cellmembers[x])or("Caid" in cellmembers[x]):
									if x<(len(cellmembers)-1):
										if cellmembers[x+1] != "0x000":
											decID = cellmembers[x+1]
											decID = decID .lstrip("0x")
											decID = decID.strip(",;.:-*_<>()[]{}")
											if (len(decID)<4):
												decID = decID + "0"
										else:
											decID = ""
					if decID != "":
						idnames = ("0100,01FF,SE","0500,05FF,VI","0600,06FF,IR","0900,09FF,NDS","0B00,0BFF,CO","0D00,0DFF,CW","1700,17FF,BC","1800,18FF,NA")
						for idline in idnames:
							IDlist = idline.split(",")
							try:
								if (int(decID,16)>=int(IDlist[0],16)) and (int(decID,16)<=int(IDlist[1],16)):
									decID = IDlist[2] + " " + decID
									break
							except:
								pass
					for cell in flines:
						if ("using:" in cell) or ("source:" in cell):
							cellmembers = cell.split()
							for x in range(len(cellmembers)):
								if ("using:" in cellmembers[x]) or ("source:" in cellmembers[x]):
									if x<(len(cellmembers)-1):
										if cellmembers[x+1] != "fta":
											decFrom = cellmembers[x+1]
										else:
											decFrom = ""
				except:
					pass
				self.text = decFrom + " " + decID
			else:
				xresol = info.getInfo(iServiceInformation.sVideoWidth)
				yresol = info.getInfo(iServiceInformation.sVideoHeight)
				if xresol>0:
					self.text = str(xresol) + " x " + str(yresol)



